#ifndef PARSER_H_
#define PARSER_H_

#include "LineBuffer.h"
#include "Token.h"

class Parser {
  private:
    LineBuffer *buffer;
    bool bufferCompleted;  // バッファ内容が完結しているか
    int blockId;  // -1: ブロック未選択、0～: ブロック選択中
    int lineCount;

  private:
    bool parseIdentifier(Token& _t, char* _s, int _count);
    bool parseNumber(Token& _t, char* _s, int _count);
  public:
    Parser(int _length);
    ~Parser();
    void clear();
    void setLineCount(int _n);
    int put(char _c);
    bool parse(Token& _t0, Token& _t1);
    bool checkRun();
    bool checkStop();
};

#endif

