#ifndef RINGBUFFER_H_
#define RINGBUFFER_H_

class RingBuffer {
private:
  // バッファのサイズ
  int length;
  // 読み取りポインタ
  int rp;
  // 書き込みポインタ
  int wp;
  // 満杯フラグ (0: 空、1: 満)
  bool full;
  // バッファの実体
  char *data;
  
public:
  RingBuffer(int _length);
  ~RingBuffer();
  void allocate(int _length);
  void deallocate();
  bool available();
  void clear();
  int put(char _c);
  int get(char& _c);
  char* getData();
};

#endif

