#ifndef TOKEN_H_
#define TOKEN_H_

enum class TokenType {
  EMPTY = 0x000,
  UNDEFINED = 0x001,
  BI_TIMER_POSEDGE0 = 0x040,
  BI_TIMER_POSEDGE1 = 0x041,
  BI_TIMER_POSEDGE2 = 0x042,
  BI_TIMER_POSEDGE3 = 0x043,
  BI_TIMER_POSEDGE4 = 0x044,
  BI_TIMER_POSEDGE5 = 0x045,
  BI_TIMER_POSEDGE6 = 0x046,
  BI_TIMER_POSEDGE7 = 0x047,
  BI_TIMER_NEGEDGE0 = 0x048,
  BI_TIMER_NEGEDGE1 = 0x049,
  BI_TIMER_NEGEDGE2 = 0x04a,
  BI_TIMER_NEGEDGE3 = 0x04b,
  BI_TIMER_NEGEDGE4 = 0x04c,
  BI_TIMER_NEGEDGE5 = 0x04d,
  BI_TIMER_NEGEDGE6 = 0x04e,
  BI_TIMER_NEGEDGE7 = 0x04f,
  BI_TIMER_LEVELTRIG0 = 0x050,
  BI_TIMER_LEVELTRIG1 = 0x051,
  BI_TIMER_LEVELTRIG2 = 0x052,
  BI_TIMER_LEVELTRIG3 = 0x053,
  BI_TIMER_LEVELTRIG4 = 0x054,
  BI_TIMER_LEVELTRIG5 = 0x055,
  BI_TIMER_LEVELTRIG6 = 0x056,
  BI_TIMER_LEVELTRIG7 = 0x057,
  BI_TIMER_RESET0 = 0x058,
  BI_TIMER_RESET1 = 0x059,
  BI_TIMER_RESET2 = 0x05a,
  BI_TIMER_RESET3 = 0x05b,
  BI_TIMER_RESET4 = 0x05c,
  BI_TIMER_RESET5 = 0x05d,
  BI_TIMER_RESET6 = 0x05e,
  BI_TIMER_RESET7 = 0x05f,
  BI_ANDGATE_INA0 = 0x060,
  BI_ANDGATE_INA1 = 0x061,
  BI_ANDGATE_INA2 = 0x062,
  BI_ANDGATE_INA3 = 0x063,
  BI_ANDGATE_INB0 = 0x064,
  BI_ANDGATE_INB1 = 0x065,
  BI_ANDGATE_INB2 = 0x066,
  BI_ANDGATE_INB3 = 0x067,
  BI_ANDGATE_INC0 = 0x068,
  BI_ANDGATE_INC1 = 0x069,
  BI_ANDGATE_INC2 = 0x06a,
  BI_ANDGATE_INC3 = 0x06b,
  BI_ANDGATE_IND0 = 0x06c,
  BI_ANDGATE_IND1 = 0x06d,
  BI_ANDGATE_IND2 = 0x06e,
  BI_ANDGATE_IND3 = 0x06f,
  BI_ANDGATE_INE0 = 0x070,
  BI_ANDGATE_INE1 = 0x071,
  BI_ANDGATE_INE2 = 0x072,
  BI_ANDGATE_INE3 = 0x073,
  BI_ANDGATE_INF0 = 0x074,
  BI_ANDGATE_INF1 = 0x075,
  BI_ANDGATE_INF2 = 0x076,
  BI_ANDGATE_INF3 = 0x077,
  BI_ANDGATE_ING0 = 0x078,
  BI_ANDGATE_ING1 = 0x079,
  BI_ANDGATE_ING2 = 0x07a,
  BI_ANDGATE_ING3 = 0x07b,
  BI_ANDGATE_INH0 = 0x07c,
  BI_ANDGATE_INH1 = 0x07d,
  BI_ANDGATE_INH2 = 0x07e,
  BI_ANDGATE_INH3 = 0x07f,
  BI_ORGATE_INA0 = 0x080,
  BI_ORGATE_INA1 = 0x081,
  BI_ORGATE_INA2 = 0x082,
  BI_ORGATE_INA3 = 0x083,
  BI_ORGATE_INB0 = 0x084,
  BI_ORGATE_INB1 = 0x085,
  BI_ORGATE_INB2 = 0x086,
  BI_ORGATE_INB3 = 0x087,
  BI_ORGATE_INC0 = 0x098,
  BI_ORGATE_INC1 = 0x089,
  BI_ORGATE_INC2 = 0x08a,
  BI_ORGATE_INC3 = 0x08b,
  BI_ORGATE_IND0 = 0x08c,
  BI_ORGATE_IND1 = 0x08d,
  BI_ORGATE_IND2 = 0x08e,
  BI_ORGATE_IND3 = 0x08f,
  BI_ORGATE_INE0 = 0x090,
  BI_ORGATE_INE1 = 0x091,
  BI_ORGATE_INE2 = 0x092,
  BI_ORGATE_INE3 = 0x093,
  BI_ORGATE_INF0 = 0x094,
  BI_ORGATE_INF1 = 0x095,
  BI_ORGATE_INF2 = 0x096,
  BI_ORGATE_INF3 = 0x097,
  BI_ORGATE_ING0 = 0x098,
  BI_ORGATE_ING1 = 0x099,
  BI_ORGATE_ING2 = 0x09a,
  BI_ORGATE_ING3 = 0x09b,
  BI_ORGATE_INH0 = 0x09c,
  BI_ORGATE_INH1 = 0x09d,
  BI_ORGATE_INH2 = 0x09e,
  BI_ORGATE_INH3 = 0x09f,
  BI_NOTGATE_IN0 = 0x0a0,
  BI_NOTGATE_IN1 = 0x0a1,
  BI_NOTGATE_IN2 = 0x0a2,
  BI_NOTGATE_IN3 = 0x0a3,
  BI_NOTGATE_IN4 = 0x0a4,
  BI_NOTGATE_IN5 = 0x0a5,
  BI_NOTGATE_IN6 = 0x0a6,
  BI_NOTGATE_IN7 = 0x0a7,
  BI_RELAY0 = 0x0a8,
  BI_RELAY1 = 0x0a9,
  BI_RELAY2 = 0x0aa,
  BI_RELAY3 = 0x0ab,
  II_JP_MUXL0 = 0x0b0,
  II_JP_MUXL1 = 0x0b1,
  II_JP_MUXL2 = 0x0b2,
  II_JP_MUXL3 = 0x0b3,
  II_JP_MUXL4 = 0x0b4,
  II_JP_MUXL5 = 0x0b5,
  II_JP_MUXH0 = 0x0b8,
  II_JP_MUXH1 = 0x0b9,
  II_JP_MUXH2 = 0x0ba,
  II_JP_MUXH3 = 0x0bb,
  II_JP_MUXH4 = 0x0bc,
  II_JP_MUXH5 = 0x0bd,
  II_TIMER_CNT0 = 0x0c0,
  II_TIMER_CNT1 = 0x0c1,
  II_TIMER_CNT2 = 0x0c2,
  II_TIMER_CNT3 = 0x0c3,
  II_TIMER_CNT4 = 0x0c4,
  II_TIMER_CNT5 = 0x0c5,
  II_TIMER_CNT6 = 0x0c6,
  II_TIMER_CNT7 = 0x0c7,
  II_TIMER_MULT0 = 0x0c8,
  II_TIMER_MULT1 = 0x0c9,
  II_TIMER_MULT2 = 0x0ca,
  II_TIMER_MULT3 = 0x0cb,
  II_TIMER_MULT4 = 0x0cc,
  II_TIMER_MULT5 = 0x0cd,
  II_TIMER_MULT6 = 0x0ce,
  II_TIMER_MULT7 = 0x0cf,
  II_ADDER_INA0 = 0x0d0,
  II_ADDER_INA1 = 0x0d1,
  II_ADDER_INA2 = 0x0d2,
  II_ADDER_INA3 = 0x0d3,
  II_ADDER_INB0 = 0x0d4,
  II_ADDER_INB1 = 0x0d5,
  II_ADDER_INB2 = 0x0d6,
  II_ADDER_INB3 = 0x0d7,
  II_MULTIPLIER_INA0 = 0x0d8,
  II_MULTIPLIER_INA1 = 0x0d9,
  II_MULTIPLIER_INA2 = 0x0da,
  II_MULTIPLIER_INA3 = 0x0db,
  II_MULTIPLIER_INB0 = 0x0dc,
  II_MULTIPLIER_INB1 = 0x0dd,
  II_MULTIPLIER_INB2 = 0x0de,
  II_MULTIPLIER_INB3 = 0x0df,
  II_VR_MAX0 = 0x0e0,
  II_VR_MAX1 = 0x0e1,
  II_VR_MAX2 = 0x0e2,
  II_VR_MAX3 = 0x0e3,
  CMD_BLOCK0 = 0x0f0,
  CMD_BLOCK1 = 0x0f1,
  CMD_BLOCK2 = 0x0f2,
  CMD_BLOCK3 = 0x0f3,
  CMD_ENDBLOCK = 0x0fa,
  CMD_DUMP = 0x0fb,
  CMD_STOP = 0x0fc,
  CMD_RUN = 0x0fd,
  NI_MAJOR_VERSION = 0x0fe,
  NI_MINOR_VERSION = 0x0ff,
  IMMEDIATE = 0x100,
  BO_CONST_DELAY = 0x140,
  BO_CONST_ALWAYS = 0x141,
  BO_PHOTO0 = 0x150,
  BO_PHOTO1 = 0x151,
  BO_PHOTO2 = 0x152,
  BO_PHOTO3 = 0x153,
  BO_JP_LEVEL0 = 0x158,
  BO_JP_LEVEL1 = 0x159,
  BO_JP_LEVEL2 = 0x15a,
  BO_JP_LEVEL3 = 0x15b,
  BO_JP_LEVEL4 = 0x15c,
  BO_JP_LEVEL5 = 0x15d,
  BO_TIMER_OUT0 = 0x160,
  BO_TIMER_OUT1 = 0x161,
  BO_TIMER_OUT2 = 0x162,
  BO_TIMER_OUT3 = 0x163,
  BO_TIMER_OUT4 = 0x164,
  BO_TIMER_OUT5 = 0x165,
  BO_TIMER_OUT6 = 0x166,
  BO_TIMER_OUT7 = 0x167,
  BO_TIMER_DELAY0 = 0x168,
  BO_TIMER_DELAY1 = 0x169,
  BO_TIMER_DELAY2 = 0x16a,
  BO_TIMER_DELAY3 = 0x16b,
  BO_TIMER_DELAY4 = 0x16c,
  BO_TIMER_DELAY5 = 0x16d,
  BO_TIMER_DELAY6 = 0x16e,
  BO_TIMER_DELAY7 = 0x16f,
  BO_ANDGATE_OUT0 = 0x170,
  BO_ANDGATE_OUT1 = 0x171,
  BO_ANDGATE_OUT2 = 0x172,
  BO_ANDGATE_OUT3 = 0x173,
  BO_ORGATE_OUT0 = 0x174,
  BO_ORGATE_OUT1 = 0x175,
  BO_ORGATE_OUT2 = 0x176,
  BO_ORGATE_OUT3 = 0x177,
  BO_NOTGATE_OUT0 = 0x178,
  BO_NOTGATE_OUT1 = 0x179,
  BO_NOTGATE_OUT2 = 0x17a,
  BO_NOTGATE_OUT3 = 0x17b,
  BO_NOTGATE_OUT4 = 0x17c,
  BO_NOTGATE_OUT5 = 0x17d,
  BO_NOTGATE_OUT6 = 0x17e,
  BO_NOTGATE_OUT7 = 0x17f,
  IO_JP_MUXOUT0 = 0x180,
  IO_JP_MUXOUT1 = 0x181,
  IO_JP_MUXOUT2 = 0x182,
  IO_JP_MUXOUT3 = 0x183,
  IO_JP_MUXOUT4 = 0x184,
  IO_JP_MUXOUT5 = 0x185,
  IO_ADDER_OUT0 = 0x190,
  IO_ADDER_OUT1 = 0x191,
  IO_ADDER_OUT2 = 0x192,
  IO_ADDER_OUT3 = 0x193,
  IO_MULTIPLIER_OUT0 = 0x194,
  IO_MULTIPLIER_OUT1 = 0x195,
  IO_MULTIPLIER_OUT2 = 0x196,
  IO_MULTIPLIER_OUT3 = 0x197,
  IO_VR_OUT0 = 0x1a0,
  IO_VR_OUT1 = 0x1a1,
  IO_VR_OUT2 = 0x1a2,
  IO_VR_OUT3 = 0x1a3,
  O_NOT_CONNECTED = 0x1ff
};

enum class NumericError {
  NO_ERROR = 0,
  OVERFLOW = 1,
  BAD_SIGN = 2,
  ILLEGAL_CHAR = 3
};

class Token {
  public:
    TokenType type;
    NumericError numErr;
    int value;
    static int BI_RANGE_BEGIN, BI_RANGE_END;
    static int II_RANGE_BEGIN, II_RANGE_END;
    static int BO_RANGE_BEGIN, BO_RANGE_END;
    static int IO_RANGE_BEGIN, IO_RANGE_END;
    static int CMD_RANGE_BEGIN, CMD_RANGE_END;
    
  public:
    bool isEmpty();
    bool isUndefined();
    bool isBinaryInput();
    bool isIntegerInput();
    bool isNumericInput();
    bool isBinaryOutput();
    bool isIntegerOutput();
    bool isCommand();
    bool isImmediate();
    int getBlockId(int _numBlocks);
};

#endif

