#ifndef WIRECODE_H_
#define WIRECODE_H_

#include "Token.h"

class WireCode {
  private:
    int blockSize;
    int numBlocks;
    unsigned char* blob;
    int blockId;  // -1: ブロック未選択、0～: ブロック番号選択中
    int lineCount;
    int immediateCount;  // 即値テーブルの使用数
    bool errorFlagWOutOfBlock;
  public:
    static int INTEGER_IMM_ADDRESS_BASE;
    static int NUM_IMM_SLOTS;

  private:
    int findImmediateIndex(int _x);
    bool getIndexedImmediate(int& _n, unsigned char _b);
  public:
    WireCode(int _blockSize, int _numBlocks = 1);
    ~WireCode();
    void clearBlob();
    void resetErrorFlags();
    void setLineCount(int _n);
    int getBlockId();
    void setBlockId(int _blockId);
    bool push(Token& _t0, Token& _t1);
    void saveBlock();
    void saveBlock(int _blockId);
    void loadBlock(int _blockId);
    void dump();
    void printVersion();
    unsigned char* getBlob();
};

#endif
